Module javafx.base
Package javafx.beans.property

# Class MapPropertyBase<K,V>

java.lang.Object
javafx.beans.binding.MapExpression<K,V>
javafx.beans.property.ReadOnlyMapProperty<K,V>
javafx.beans.property.MapProperty<K,V>
javafx.beans.property.MapPropertyBase<K,V>

Type Parameters:
  `K` - the type of the key elements of the `Map`
  `V` - the type of the value elements of the `Map`

All Implemented Interfaces:
  `Map<K,V>`, `Observable`, `Property<ObservableMap<K,V>>`, `ReadOnlyProperty<ObservableMap<K,V>>`, `ObservableMapValue<K,V>`, `ObservableObjectValue<ObservableMap<K,V>>`, `ObservableValue<ObservableMap<K,V>>`, `WritableMapValue<K,V>`, `WritableObjectValue<ObservableMap<K,V>>`, `WritableValue<ObservableMap<K,V>>`, `ObservableMap<K,V>`

Direct Known Subclasses:
  `SimpleMapProperty`

public abstract class MapPropertyBase<K,V> extends MapProperty<K,V>
The class `MapPropertyBase` is the base class for a property wrapping an `ObservableMap`. It provides all the functionality required for a property except for the `ReadOnlyProperty.getBean()` and `ReadOnlyProperty.getName()` methods, which must be implemented by extending classes.

Since:
  JavaFX 2.1
See Also:
  - `ObservableMap`
  - `MapProperty`

- ## Property Summary

  Properties
  Type
  Property
  Description
  `ReadOnlyBooleanProperty`
  `empty`
  A boolean property that is `true`, if the map is empty.
  `ReadOnlyIntegerProperty`
  `size`
  An integer property that represents the size of the map.

- ## Nested Class Summary

  ## Nested classes/interfaces declared in interface java.util.Map

  `Map.Entry<K,V>`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MapPropertyBase()`
  The Constructor of `MapPropertyBase`
  `MapPropertyBase(ObservableMap<K,V> initialValue)`
  The constructor of the `MapPropertyBase`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addListener(InvalidationListener listener)`
  Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid.
  `void`
  `addListener(ChangeListener<? super ObservableMap<K,V>> listener)`
  Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes.
  `void`
  `addListener(MapChangeListener<? super K,? super V> listener)`
  Add a listener to this observable map.
  `void`
  `bind(ObservableValue<? extends ObservableMap<K,V>> newObservable)`
  Create a unidirection binding for this `Property`.
  `ReadOnlyBooleanProperty`
  `emptyProperty()`
  A boolean property that is `true`, if the map is empty.
  `protected void`
  `fireValueChangedEvent()`
  Sends notifications to all attached `InvalidationListeners`, `ChangeListeners`, and `MapChangeListener`.
  `protected void`
  `fireValueChangedEvent(MapChangeListener.Change<? extends K,? extends V> change)`
  Sends notifications to all attached `InvalidationListeners`, `ChangeListeners`, and `MapChangeListener`.
  `ObservableMap<K,V>`
  `get()`
  Get the wrapped value.
  `protected void`
  `invalidated()`
  The method `invalidated()` can be overridden to receive invalidation notifications.
  `boolean`
  `isBound()`
  Can be used to check, if a `Property` is bound.
  `void`
  `removeListener(InvalidationListener listener)`
  Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.
  `void`
  `removeListener(ChangeListener<? super ObservableMap<K,V>> listener)`
  Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.
  `void`
  `removeListener(MapChangeListener<? super K,? super V> listener)`
  Tries to removed a listener from this observable map.
  `void`
  `set(ObservableMap<K,V> newValue)`
  Set the wrapped value.
  `ReadOnlyIntegerProperty`
  `sizeProperty()`
  An integer property that represents the size of the map.
  `String`
  `toString()`
  Returns a string representation of this `MapPropertyBase` object.
  `void`
  `unbind()`
  Remove the unidirectional binding for this `Property`.

  ### Methods declared in class javafx.beans.property.MapProperty

  `bindBidirectional, setValue, unbindBidirectional`

  ### Methods declared in class javafx.beans.property.ReadOnlyMapProperty

  `bindContent, bindContentBidirectional, equals, hashCode, unbindContent, unbindContentBidirectional`

  ### Methods declared in class javafx.beans.binding.MapExpression

  `asString, clear, containsKey, containsValue, entrySet, get, getSize, getValue, isEmpty, isEqualTo, isNotEqualTo, isNotNull, isNull, keySet, mapExpression, put, putAll, remove, size, valueAt, valueAt, values`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods declared in interface java.util.Map

  `clear, compute, computeIfAbsent, computeIfPresent, containsKey, containsValue, entrySet, equals, forEach, get, getOrDefault, hashCode, isEmpty, keySet, merge, put, putAll, putIfAbsent, remove, remove, replace, replace, replaceAll, size, values`

  ### Methods declared in interface javafx.beans.Observable

  `subscribe`

  ### Methods declared in interface javafx.beans.value.ObservableValue

  `flatMap, getValue, map, orElse, subscribe, subscribe, when`

  ### Methods declared in interface javafx.beans.property.ReadOnlyProperty

  `getBean, getName`

  ### Methods declared in interface javafx.beans.value.WritableValue

  `getValue`

- ## Property Details

  - ### size

    public ReadOnlyIntegerProperty sizeProperty
    Specified by:
      `sizeProperty` in class `MapExpression<K,V>`
    Returns:
      the property
    See Also:
      - `sizeProperty()`

  - ### empty

    public ReadOnlyBooleanProperty emptyProperty
    Specified by:
      `emptyProperty` in class `MapExpression<K,V>`
    Returns:
      the `ReadOnlyBooleanProperty`
    See Also:
      - `emptyProperty()`

- ## Constructor Details

  - ### MapPropertyBase

    public MapPropertyBase()
    The Constructor of `MapPropertyBase`

  - ### MapPropertyBase

    public MapPropertyBase(ObservableMap<K,V> initialValue)
    The constructor of the `MapPropertyBase`.
    Parameters:
      `initialValue` - the initial value of the wrapped value

- ## Method Details

  - ### sizeProperty

    public ReadOnlyIntegerProperty sizeProperty()
    Description copied from class: `MapExpression`
    An integer property that represents the size of the map.
    Specified by:
      `sizeProperty` in class `MapExpression<K,V>`
    Returns:
      the `size` property
    See Also:
      - `MapExpression.getSize()`

  - ### emptyProperty

    public ReadOnlyBooleanProperty emptyProperty()
    Description copied from class: `MapExpression`
    A boolean property that is `true`, if the map is empty.
    Specified by:
      `emptyProperty` in class `MapExpression<K,V>`
    Returns:
      the `empty` property
    See Also:
      - `MapExpression.isEmpty()`

  - ### addListener

    public void addListener(InvalidationListener listener)
    Description copied from interface: `Observable`
    Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

    Note that the same actual `InvalidationListener` instance may be safely registered for different `Observables`.

    The `Observable` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakInvalidationListener` avoid this situation.

    Parameters:
      `listener` - The listener to register
    See Also:
      - `Observable.removeListener(InvalidationListener)`

  - ### removeListener

    public void removeListener(InvalidationListener listener)
    Description copied from interface: `Observable`
    Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.

    If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

    Parameters:
      `listener` - The listener to remove
    See Also:
      - `Observable.addListener(InvalidationListener)`

  - ### addListener

    public void addListener(ChangeListener<? super ObservableMap<K,V>> listener)
    Description copied from interface: `ObservableValue`
    Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

    Note that the same actual `ChangeListener` instance may be safely registered for different `ObservableValues`.

    The `ObservableValue` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakChangeListener` avoid this situation.

    Parameters:
      `listener` - The listener to register
    See Also:
      - `ObservableValue.removeListener(ChangeListener)`

  - ### removeListener

    public void removeListener(ChangeListener<? super ObservableMap<K,V>> listener)
    Description copied from interface: `ObservableValue`
    Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.

    If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

    Parameters:
      `listener` - The listener to remove
    See Also:
      - `ObservableValue.addListener(ChangeListener)`

  - ### addListener

    public void addListener(MapChangeListener<? super K,? super V> listener)
    Description copied from interface: `ObservableMap`
    Add a listener to this observable map.
    Parameters:
      `listener` - the listener for listening to the list changes

  - ### removeListener

    public void removeListener(MapChangeListener<? super K,? super V> listener)
    Description copied from interface: `ObservableMap`
    Tries to removed a listener from this observable map. If the listener is not attached to this map, nothing happens.
    Parameters:
      `listener` - a listener to remove

  - ### fireValueChangedEvent

    protected void fireValueChangedEvent()
    Sends notifications to all attached `InvalidationListeners`, `ChangeListeners`, and `MapChangeListener`. This method is called when the value is changed, either manually by calling `set(javafx.collections.ObservableMap)` or in case of a bound property, if the binding becomes invalid.

  - ### fireValueChangedEvent

    protected void fireValueChangedEvent(MapChangeListener.Change<? extends K,? extends V> change)
    Sends notifications to all attached `InvalidationListeners`, `ChangeListeners`, and `MapChangeListener`. This method is called when the content of the list changes.
    Parameters:
      `change` - the change that needs to be propagated

  - ### invalidated

    protected void invalidated()
    The method `invalidated()` can be overridden to receive invalidation notifications. This is the preferred option in `Objects` defining the property, because it requires less memory. The default implementation is empty.

  - ### get

    public ObservableMap<K,V> get()
    Description copied from interface: `WritableObjectValue`
    Get the wrapped value. This must be identical to the value returned from `WritableValue.getValue()`.

    This method exists only to align WritableObjectValue API with `WritableBooleanValue` and subclasses of `WritableNumberValue`

    Returns:
      The current value

  - ### set

    public void set(ObservableMap<K,V> newValue)
    Description copied from interface: `WritableObjectValue`
    Set the wrapped value. Should be equivalent to `WritableValue.setValue(java.lang.Object)`
    Parameters:
      `newValue` - The new value
    See Also:
      - `WritableObjectValue.get()`

  - ### isBound

    public boolean isBound()
    Description copied from interface: `Property`
    Can be used to check, if a `Property` is bound.
    Returns:
      `true` if the `Property` is bound, `false` otherwise
    See Also:
      - `Property.bind(javafx.beans.value.ObservableValue)`

  - ### bind

    public void bind(ObservableValue<? extends ObservableMap<K,V>> newObservable)
    Description copied from interface: `Property`
    Create a unidirection binding for this `Property`.

    Note that JavaFX has all the bind calls implemented through weak listeners. This means the bound property can be garbage collected and stopped from being updated.

    Parameters:
      `newObservable` - The observable this `Property` should be bound to.

  - ### unbind

    public void unbind()
    Description copied from interface: `Property`
    Remove the unidirectional binding for this `Property`. If the `Property` is not bound, calling this method has no effect.
    See Also:
      - `Property.bind(javafx.beans.value.ObservableValue)`

  - ### toString

    public String toString()
    Returns a string representation of this `MapPropertyBase` object.
    Overrides:
      `toString` in class `MapProperty<K,V>`
    Returns:
      a string representation of this `MapPropertyBase` object.